#include "simul.h"
#define NEL(st) (sizeof(st)/sizeof((st)[0])) 
typedef struct {
	float *cH;
	int nH;
	float *cHtilde;
	int nHtilde;
	int offH, offG, offHtilde, offGtilde;
} waveletfilter;
extern struct poss_filters {
     waveletfilter *filter;
     char *name;
     char *abr;
     }wfilters[];
extern waveletfilter *actfil;
extern int numfil;


struct alltrafos{
  char *full;
  char *abr;
  int num;
  }trf[]={{"Walsh-Hadamard","wh",TWH},
          {"Walsh-Palley","wp",TWP},
          {"Walsh v sekv. usporiadani","ws",TWS},
          {"Slant-Hadamard","sh",TSH},
          {"Slant-Palley","sp",TSP},
          {"Slant v sekv. usporiadani","ss",TSS},
          {"Haarova","ht",THA},
          {"Hartleyova","hy",THY},
          {"Hartleyova preusporiadana","hyp",THYP},
          {"Cosinusova","cos",TCOS},
          {"Fourierova","f",TF},
          {"Fourierova preusporiadana","fp",TFP},
          {"Waveletova standardna","wav",WAV},
          {"Waveletova nestandardna","wan",WAN},
          {"Waveletova hilbertova","wah",WAH}};

int NUMTRAFO=NEL(trf);
int wfil[MAXTABR];
 
/********************************************************************/
wav_help()
{int i;
 printf("Platne wavelety su:\n");
 for(i=0;i<numfil;i++)
   printf("%s (%s)\n",wfilters[i].name,wfilters[i].abr);
 }
/********************************************************************/
tr_help()
{int i;
 printf("Platne transformacie su:\n");
 for(i=0;i<(int)NUMTRAFO;i++)
   printf("%d) %s (%s)\n",trf[i].num,trf[i].full,trf[i].abr);
 }
/********************************************************************/
validate (input,trnum)
char *input;
int *trnum;
{int i;
  for(i=0;i<(int)NUMTRAFO;i++)
   if(strcmp(input,trf[i].abr)==0)break;
 if(i<(int)NUMTRAFO)*trnum=trf[i].num;
 else *trnum=0;
 }
/********************************************************************/
wvalid (count,input)
int count;
char *input;
{int i;
  for(i=0;i<numfil;i++)
   if(strcmp(input,wfilters[i].abr)==0)break;
 if(i<numfil)
   wfil[count]=i+1;
 else {wav_help();
       exit(1);
       }
 }

/********************************************************************/
gettrafos(subor,numreaded)
char *subor;
int *numreaded;
{ FILE *trafofile;
  char xname[MAXTABR],yname[MAXTABR];
  int count=0,xval,yval,i;
  if((trafofile=fopen(subor,"r"))==0)
    {printf("neviem najst subor %s s transformaciami \n",subor);
     exit(1);}
  printf("Transformacie beriem zo suboru : %s\n",subor); 
  while(fscanf(trafofile,"%s%s",xname,yname)!=EOF)
   {if(count>(int)MAXDAVKA){printf("Privela transformacii\n");exit(1);}
    validate(xname,&xval);
    if((xval==WAV)||(xval==WAN)||(xval==WAH))
      {wvalid(count,yname);
       yval=xval;
       }
    else validate(yname,&yval);
    if((xval==0)||(yval==0))
      {printf("neznama transformacia v riadku %d :%s %s\n",
               count+1,xname,yname);
       tr_help();
       exit(1);
       }
    trdef.xnum[count]=xval;trdef.ynum[count]=yval;
    count++;
    };
  printf("Uspesne nacitanych %d transformacii :\n",count);
  for(i=0;i<count;i++)
    {xval=trdef.xnum[i];yval=trdef.ynum[i];
     printf("%d) X:%s Y:%s   ",i+1,trf[xval-1].abr,trf[yval-1].abr);
     }
  printf("\n");  
  *numreaded=count;
  trdef.allnum=count;
  fclose(trafofile);
  }
/********************************************************************/
actualize_trafo(poradie)
int poradie;
{int xtr,ytr,i;
 xtr=trdef.txnum=trdef.xnum[poradie];
 ytr=trdef.tynum=trdef.ynum[poradie];
 strcpy(trdef.txname,trf[xtr-1].full);
 strcpy(trdef.tyname,trf[ytr-1].full);
 strcpy(trdef.txabr,trf[xtr-1].abr);
 strcpy(trdef.tyabr,trf[ytr-1].abr);
 printf("Transformacia v smere X: %s %s %d\n",trdef.txname,trdef.txabr,trdef.txnum);
 printf("Transformacia v smere Y: %s %s %d\n",trdef.tyname,trdef.tyabr,trdef.tynum);
 if((xtr==WAV)||(xtr==WAN)||(xtr==WAH))
  {i=wfil[poradie];/* typ filtra */
   if(i==0){printf("chyba  aktualizacie filtra \n");exit;}
   else i--;
   actfil=wfilters[i].filter;
   printf("Pouzity wavelet je typu: %s\n",wfilters[i].name);   
   }; 
 }
/********************************************************************/
 wavepopis(subor,poradie)
 FILE *subor;
 int poradie;
 {int i=trdef.xnum[poradie];
  if((i==WAV)||(i==WAN)||(i==WAH))
    {i=wfil[poradie]-1;
     fprintf(subor,"Pouzity wavelet je typu: %s\n",wfilters[i].name); 
     };
  }
       
     
/********************************************************************/
act_from_num(xtr,ytr)
int xtr,ytr;
{strcpy(trdef.txname,trf[xtr-1].full);
 strcpy(trdef.tyname,trf[ytr-1].full);
 strcpy(trdef.txabr,trf[xtr-1].abr);
 strcpy(trdef.tyabr,trf[ytr-1].abr);
 printf("Transformacia v smere X: %s %s %d\n",trdef.txname,trdef.txabr,trdef.txnum);
 printf("Transformacia v smere Y: %s %s %d\n",trdef.tyname,trdef.tyabr,trdef.tynum);
 }
