#include <math.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#define MAXX 2048

  XSizeHints  xsh;
  XWindowAttributes attrib;
  Display    *dpy;
  Window      win;
  GC          mygc;
  XEvent      event;
  KeySym      mykey;
  int         scr;
  int         globx;
  float       entropy; 
/*----------------------------------------------------------------------------*/
/*         Globalne premenne , ktore charakterizuju geometriu okna            */
/*----------------------------------------------------------------------------*/
  int siz=256,zacx=40,xlres=40,xpres=20,zacy=45,yhres=45,ydres=20;
/*----------------------------------------------------------------------------*/
/* Vypocita entropiu zo zadaneho pola 256 pocetnosti                          */
/*----------------------------------------------------------------------------*/
float entropia(pocet)
float pocet[];
{int a;
 float suma=0,pomoc=0;
 for(a=0;a<256;a++)
   suma+=pocet[a]; 
 for(a=0;a<256;a++)
   if(pocet[a]>0)pomoc-=pocet[a]/suma*log(pocet[a]/suma)/log(2.0);
 return(pomoc);
 } 
/*----------------------------------------------------------------------------*/
/*Zo zadaneho suboru v pic formate zisti pocetnosti hodnot a ich maximum      */
/*----------------------------------------------------------------------------*/
citaj_pocetnosti(pocet,max,obrazok)
float pocet[];
char *obrazok;
float *max;
{int i,j,fd1,width,height;
 unsigned char buf[MAXX];
 fd1=open(obrazok,0);
 if(fd1 == -1)
   { perror("chyba pri otvoreni vst. dat. suboru");exit(1);}
 lseek(fd1,0L,0);read(fd1,buf,4);
 width=buf[0]+256*buf[1];
 height=buf[2]+256*buf[3];

 for(i=0;i<height;i++)
   {if(read(fd1,buf,width)!=width)
      {perror("chyba dat v subore");exit(1);}
    for(j=0;j<width;j++) pocet[buf[j]]++;
    }
 *max=0;
 for(i=0;i<256;i++)
   if(pocet[i]>*max)*max=pocet[i]; 
 }
/*----------------------------------------------------------------------------*/
/* Na aktualnom Displayi vytvori okno                                         */
/*----------------------------------------------------------------------------*/
initwin(minx,miny,maxx,maxy,obrazok)
  int minx,miny,maxx,maxy;
  char *obrazok; 
{ char nazov[255];
  sprintf(nazov,"Histogram: '%s'",obrazok);
  xsh.x = minx;xsh.y = miny;
  xsh.width =maxx;
xsh.height=maxy;
  xsh.flags=PPosition | PSize;
  win = XCreateSimpleWindow(dpy,DefaultRootWindow(dpy),
                            xsh.x,xsh.y,xsh.width,xsh.height,
                            5,BlackPixel(dpy,scr),WhitePixel(dpy,scr)
                            );
  XSetStandardProperties(dpy,win,nazov,nazov,None,0,0,&xsh);
  mygc = XCreateGC(dpy,win,0,0);
  XSetBackground(dpy,mygc,WhitePixel(dpy,scr));
  XSetForeground(dpy,mygc,BlackPixel(dpy,scr));
  XSelectInput(dpy,win,ButtonPressMask|ButtonReleaseMask|
               ButtonMotionMask|KeyPressMask|
               EnterWindowMask|LeaveWindowMask|ExposureMask
               );
  XMapRaised(dpy,win);
  } 
/*----------------------------------------------------------------------------*/
/*  Procedura na vypisovanie pocetnosti na aktualej polohe mysi               */
/*----------------------------------------------------------------------------*/
hlas(pocet,posit,type)
float pocet[];
int posit,type;
{char popis[50];
 if(type==0)
    strcpy(popis,"               ");
 else
    {posit-=globx;
     if((posit>255)||(posit<0))
       strcpy(popis,"               ");
     else
       sprintf(popis,"X:%03d VAL:%5d",posit,(int)pocet[posit]);
     }
 XDrawImageString(dpy,win,mygc,zacx+70,zacy-32,popis,strlen(popis));
 }
/*----------------------------------------------------------------------------*/
/* Hlavna procedura na vykreslenie histogramu .                               */
/* Najprv vypocita jeho optimalnu polohu v okne , potom kresli osi + ich popis*/   
/* a nakoniec pocetnosti                                                      */
/*----------------------------------------------------------------------------*/
draw_it(width,height,pocet,max)
int width,height;
float pocet[],max;
{char popis[50];
 int i,axi,prv;
 float xmag,ymag;
 axi=7;prv=3;
 zacx= width > (siz+xlres+xpres)?xlres+(width-siz-xpres-xlres)/2:xlres;
 zacy= height> (siz+yhres+ydres)?yhres+(height-siz-yhres-ydres)/2:yhres; 
 sprintf(popis,"ENTROPIA: %f",entropy);
 XDrawImageString(dpy,win,mygc,zacx+64,zacy-16,popis,strlen(popis));
 XDrawImageString(dpy,win,mygc,zacx-12,zacy+siz+16,"0",1);
 XDrawLine(dpy,win,mygc,zacx,zacy+siz+axi,zacx,zacy-axi,zacx);
 XDrawLine(dpy,win,mygc,zacx-axi,zacy+siz,zacx+siz+axi,zacy+siz);
 for(i= -1;i<siz;i+=32)
   if(i>0){sprintf(popis,"%5d",(int)(max/(siz-1)*i));
           XDrawImageString(dpy,win,mygc,zacx-38,zacy+siz-i+4,popis,strlen(popis));
           XDrawLine(dpy,win,mygc,zacx,zacy+siz-i,zacx-prv,zacy+siz-i);
            }
  zacx++;
  for(i= -1;i<siz;i+=32)
   if(i>0){sprintf(popis,"%3d",i);
           XDrawImageString(dpy,win,mygc,zacx+i-12,zacy+siz+16,popis,strlen(popis));
           XDrawLine(dpy,win,mygc,zacx+i,zacy+siz,zacx+i,zacy+siz+prv);
            }
  for(i=0;i<256;i++)
    XDrawLine(dpy,win,mygc,zacx+i,zacy+siz,zacx+i,zacy+(int)(siz-siz*(pocet[i])/max));        
  globx=zacx;         
   }
/*----------------------------------------------------------------------------*/
/* Hlavna procedura progamu .                                                 */
/* Najprv inicializuje potrebna struktury, potom vchadza do slucky, v ktorej  */
/* sa riadi X-udalostami od uzivatela, tj: quit,vypisovanie hodnot  alebo     */
/* zmena velkosti okna                                                        */
/*----------------------------------------------------------------------------*/
main(argc,argv)
    int argc;
    char **argv;
{ char obrazok[255],text[10],znak;
  float pocet[256],max;
  int i,done,leave,width,height;
  if(argc>1) strcpy(obrazok,argv[1]);
  else
    {printf("************************************************\n");
     printf("*      Program na kreslenie histogramov        *\n");
     printf("************************************************\n");
     printf("* OVLADANIE:  q - QUIT                         *\n");
     printf("*             tlacidla mysi - pozretie hodnoty *\n");
     printf("*                             na akt. pozicii  *\n");
     printf("************************************************\n");
     printf("zadaj vstupny subor:");scanf("%s",obrazok);};
  citaj_pocetnosti(pocet,&max,obrazok);
  entropy=entropia(pocet);

  if ((dpy = XOpenDisplay("")) == NULL)
    {perror("nemozem otvorit display \n");exit(1);}
  scr = DefaultScreen(dpy);
  width=350;height=350;  
  initwin(0,0,width,height,obrazok);
  done=0;
  while(done==0)
    {leave=0;
     while(leave==0)
       {
XNextEvent(dpy,&event);
        switch(event.type)
          {case Expose:while(XCheckTypedEvent(dpy,Expose,&event));
                       XGetWindowAttributes(dpy,win,&attrib);
                       if((attrib.width!=width)||(attrib.height!=height))
                          {width=attrib.width;height=attrib.height;}
                       draw_it(width,height,pocet,max);break;
           case MappingNotify:
XRefreshKeyboardMapping(&event);break;
           case KeyPress:
i=XLookupString(&event,text,10,&mykey,0);                                        
             
                           if (i==1 && tolower(text[0]) == 'q'){leave=1;done =1 ;}; 
                         break;
           case ButtonRelease:hlas(pocet,0,0);break;
           case MotionNotify:
           case ButtonPress:hlas(pocet,event.xbutton.x,1);
                            break;
           };
        } 
    }
  XFreeGC(dpy,mygc);
  XDestroyWindow(dpy,win);
  XCloseDisplay(dpy);
  }