/* Prezerac obrazkov vo formate PIC .                   */
/* 1995 R.Vargic                                        */
/* Upravene do proceduralneho tvaru                     */
/* Pridane: 1) Prisposobenie obrazku velkosti okna      */
/*          2) Vypisovanie suradnic a skutocnej hodnoty */

#include <malloc.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define MAXX 2048
#define MAXY 1024
#define full 8
#define MGMIN 1.0/8
#define MGMAX 8
#define menux  128
#define menuy  30
 XColor gray[256];
 Display    *dpy;
 Window      win;
 XWindowAttributes attrib;
 GC          mygc;
 XSizeHints  xsh;
 Colormap cmap;
 Pixmap mypixmap;
 int scr,depth,root,inv;
 char *host;
/*---------------------------------------------------------------------------------------*/
/* Nacita obrazok zo suboru PIC do bytoveho pola ,ktoremu alokuje pamat .                */
/*---------------------------------------------------------------------------------------*/
loadpic(dat,vx,vy,subor)
unsigned char  *dat[];
int     *vx,*vy;
char    *subor;
{unsigned char buf[2048];
 long fp1,nread;
 int a,b,fd1;
 fd1=open(subor,0);
 if(fd1 == -1)
   {perror("chyba vst. dat. suboru");
	exit(1);
	}
 fp1=lseek(fd1,0L,0);
 nread=read(fd1,buf,4);
 *vx=buf[0]+256*buf[1];
 *vy=buf[2]+256*buf[3];
 fp1=lseek(fd1,4L,0);
 for(a=0;a<*vy;a++)
   {if((dat[a] = (unsigned char *)calloc(*vx,1))==0)
	  {perror("Chyba pri alokacii pamati");
	   exit(0);}
	if((nread=read(fd1,dat[a],*vx))!= *vx)
	  {perror("Cybny format PIC suboru");
	   exit(0);};
	}
 close(fd1);
 }
/*---------------------------------------------------------------------------------------*/
/* Invertuje Bytove pole dat.                                                            */
/*---------------------------------------------------------------------------------------*/
invert(dat,vx,vy)
unsigned char  *dat[];
int     vx,vy;
{int a,b;
  for(a=0;a<vy;a++)
    for(b=0;b<vx;b++)
      *(dat[a]+b)=255- *(dat[a]+b);
 }
/*-----------------------------------------------------------------*/
/* Prepise nacitane data do Image struktury podla aktualnej mierky */
/* Alokuje pamat a pripadne robi dithering (black/white monitory)  */
/*-----------------------------------------------------------------*/
pic_to_image(dat,vx,vy,pimage,magx,magy)
 unsigned char    *dat[];
	int     vx,vy;
	XImage  **pimage;
	float     magx,magy;
{
 int    bpr,dathod,pox,poy,dox,doy,a,b;
 XImage **hhmage;
 float  i,j;
 int 	bitmap_pad,format,pix[2];
 int  *pole[MAXX];

 /* ----------- alokovanie podla typu displaya -------------------*/
 if(depth == 1)
   {format = XYPixmap ;
	bitmap_pad = 32;
	}
 else{format = ZPixmap ;
	  bitmap_pad = 8;
	  };
  *pimage =XCreateImage(dpy,DefaultVisual(dpy,scr),depth,
			format,0,0,(int)(magx*vx),(int)(magy*vy),
			bitmap_pad,0
			);
 if ( *pimage == 0)
   {perror("chyba  struktury v programe");exit(0);}
 bpr = (*pimage)->bytes_per_line;
 (*pimage)->data = (char *) calloc((int)(magy*vy),bpr ) ;
 if((*pimage)->data== 0)
   {printf("chyba pri alokacii");
	exit(1);}

 if(depth==1)
   {dox= (int)(magx*vx);doy=(int)(magy*vy);
 	for(a=0;a<doy;a++)
	  pole[a]=(int *) calloc (dox,sizeof(int) );
 	}
/*------prepis s magnify--------*/
poy=0;
 for(i=0;i+0.1<vy;i+=1/magy)
   {pox=0;
	for(j=0;j+0.1<vx;j+=1/magx)
	  {dathod= *(dat[(int)i]+(int)j);
	   if(depth==8)
                 XPutPixel(*pimage,pox,poy,gray[dathod/2].pixel);
	   else
		 *(pole[poy]+pox)=dathod;
	   pox++;
	   }
	poy++;
	};
 /*------dithering, ak (black/white monitor) --------*/
 if(depth==1)
   {int chyba,pom;
   for(a=0;a<doy-1;a++)
      for(b=0;b<dox-1;b++)
        {pom= *(pole[a]+b)>128 ? 255 : 0 ;
         chyba= *(pole[a]+b)-pom;
         *(pole[a]+b)=pom;
         *(pole[a]+b+1)+=chyba/3;
         *(pole[a+1]+b)+= chyba/3;
         *(pole[a+1]+b+1)+= chyba/3;
          }
    pix[0]=BlackPixel(dpy,scr);
    pix[1]=WhitePixel(dpy,scr);
 	for(a=0;a<doy;a++)
	  for(b=0;b<dox;b++)
		XPutPixel(*pimage,b,a,pix[*(pole[a]+b)/128]);

	}
}
/*--------------------------------------------------------------------------------*/
/* Otvori display na zelanom pocitaci , pri Grayscale alebo Color monitoroch sa   */
/* snazi alokovat 128 farieb (ako stupne sedi)                                    */
/*--------------------------------------------------------------------------------*/
rob_display_a_farby(host)
char *host;
{int chyby,cell,intensity;
 if ((dpy = XOpenDisplay(host)) == NULL)
   {printf("nemozem otvorit display:%s\n",host);
	exit(1);
	}
 scr = DefaultScreen(dpy);
 depth = DefaultDepth (dpy,DefaultScreen(dpy));
 if(depth==full)
   {cmap = DefaultColormap(dpy, DefaultScreen(dpy));
	chyby=0;
	for(cell=0;cell < 128;cell++)
	  { intensity = cell * 65536L / 128L;
		gray[cell].red=gray[cell].green = gray[cell].blue = intensity;
		if(!XAllocColor(dpy,cmap,&(gray[cell])))chyby++;
		}
	if(chyby)printf("Neda sa alokovat %d farieb\n",chyby);
	}
 }

/*--------------------------------------------------------------------------------*/
/* Vykresli obrazok v root okne zvoleneho Displaya (ako pixmapa )                 */
/*--------------------------------------------------------------------------------*/
do_root(image,width,height)
 XImage **image;
 int width,height;
{int a,b,winwidth,winheight;
 XSetWindowAttributes attr;
 winwidth = XDisplayWidth(dpy,scr);
 winheight = XDisplayHeight(dpy,scr);
 win=RootWindow(dpy,scr);
 mygc=DefaultGC(dpy,scr);
 mypixmap=XCreatePixmap(dpy,win,winwidth,winheight,depth);
 mygc = XCreateGC(dpy,mypixmap,0,0);
 XSelectInput(dpy,win,StructureNotifyMask);
  for(a=0;a<winwidth;a+=width)
   for(b=0;b<winheight;b+=height)
	 XPutImage(dpy,mypixmap,mygc,image,0,0,a,b,width,height);
 XSetWindowBackgroundPixmap(dpy,win,mypixmap);
 XClearWindow(dpy,win);
 XSync(dpy, 0);
 exit(0);
 }

/*--------------------------------------------------------------------------------*/
/* Vytvara graficky kontext pre zvolene okno                                      */
/*--------------------------------------------------------------------------------*/
do_GC()
{mygc = XCreateGC(dpy,win,0,0);
 if(depth==full)
   {XSetBackground(dpy,mygc,gray[127]);
	XSetForeground(dpy,mygc,gray[0]);
	}
 else{XSetBackground(dpy,mygc,WhitePixel(dpy,scr));
	  XSetForeground(dpy,mygc,BlackPixel(dpy,scr));
	  }
 XSelectInput(dpy,win,ButtonPressMask|ButtonReleaseMask|ButtonMotionMask|
			  KeyPressMask|EnterWindowMask|LeaveWindowMask|ExposureMask);
 XMapRaised(dpy,win);
  }

/*--------------------------------------------------------------------------------*/
/* Hlavna procedura programu                                                      */
/* najprv inicializuje potrebne struktury a potom vchadza do slucky , v ktorej na */
/* zaklade X-udalosti od uzivatela meni velkost okna,vypisuje data, pripadne konci*/
/*--------------------------------------------------------------------------------*/
main(argc,argv)
	int argc;
	char **argv;
{ int vx,vy;
  unsigned char *dat[MAXY];
  float magx=1,magy=1;
  XImage *image;
  int leave,done,width,height,wstate;
  char obrazok[255];
  char info[30],text[10],znak;
  int dxpos,dypos,posx,posy;
  XEvent      event;
  KeySym      mykey;

  root=0;wstate=1;inv=0;
  if(argc>1)
	{strcpy(obrazok,argv[1]);
	 if(argc>2 && *argv[2]=='i')inv=1;
         if(argc>2 && *(argv[2]+1)=='r')root=1;
	 if(argc>3){host=argv[3];} else host = (char *) getenv("DISPLAY");
	 }
  else
	 {printf("******************************************************************\n");
	  printf("*             PREZERAC OBRAZKOV VO FORMATE PIC                   *\n");
	  printf("*----------------------------------------------------------------*\n");
	  printf("* OVLADANIE: m - zmensenie na polovicu                           *\n");
          printf("*            v - zvacsenie na dvojnasobok                        *\n");
          printf("*            o - orginalna velkost                               *\n");
          printf("*            i - invertovanie                                    *\n");
          printf("*            r - presun do root okna                             *\n");
	  printf("*            q - koniec                                          *\n");
	  printf("*            lave  tlac. mysi  - ukaze svetlost bodu  (UK)       *\n");
	  printf("*            prave tlac. mysi  - ako lave + zmeni polohu (UK)    *\n");
	  printf("*                                na aktualnu                     *\n");
	  printf("*    (pri vsetkych poveloch  musi byt mys nastavena na obrazku)  *\n");
	  printf("*----------------------------------------------------------------*\n");
	  printf("* STARTOVANIE: <meno> [subor.pic] {nepovinne [ir] [host]}        *\n");
	  printf("*              i - zobrazi inverzne                              *\n");
	  printf("*              r - zobrazi v root okne                           *\n");
          printf("*              [host] - zobrazi na displayi 'host'.napr:'kid2:0' *\n");
	  printf("******************************************************************\n");
	  printf("zadaj vstupny subor:");
	  scanf("%s",obrazok);
	  };
  rob_display_a_farby(host);
  loadpic(dat,&vx,&vy,obrazok);
  if(inv)invert(dat,vx,vy);
  posx=0;posy=10;
  wstate=1;
  done=0; 
  do{   pic_to_image(dat,vx,vy,&image,magx,magy);
        width =(int)(magx*vx);
	height=(int)(magy*vy);
	xsh.x = 0;xsh.y = 0;
	xsh.flags=PPosition | PSize;
	xsh.width=width;
        xsh.height=height;
	if(root)
	  do_root(image,width,height);
	else
          {win = XCreateSimpleWindow(dpy,DefaultRootWindow(dpy),
                                     xsh.x,xsh.y,xsh.width,xsh.height,5,
		                     BlackPixel(dpy,scr),WhitePixel(dpy,scr)
		                     );
           XSetStandardProperties(dpy,win,obrazok,obrazok,None,argv,argc,&xsh);
           }
       do_GC();
       leave=0;
       while(leave==0)
	 {XNextEvent(dpy,&event);
          switch(event.type)
	   {case Expose:while(XCheckTypedEvent(dpy,Expose,&event));
                        XGetWindowAttributes(dpy,win,&attrib);
                         if((attrib.width!=width)||(attrib.height!=height))
                            {free(image->data);
                             width=attrib.width;height=attrib.height;
                             magx=(float)width/vx;magy=(float)height/vy;
                             pic_to_image(dat,vx,vy,&image,magx,magy);
                             }
                        XPutImage(dpy,win,mygc,image,0,0,0,0,width,height);
			XFlush(dpy);
			break;
		case ButtonRelease:XPutImage(dpy,win,mygc,image,0,0,0,0,width,height);
						   XFlush(dpy);
						   break;
		case EnterNotify:wstate=1;break;
		case LeaveNotify:wstate=0;break;
                case 
ConfigureNotify:printf("konfiguracia\n");break;
		case ButtonPress:
		case MotionNotify:if(wstate)
				    {if(event.xbutton.button==3)
					{posx=event.xbutton.x;
					 posy=event.xbutton.y;
					 }
				     else
					{dypos=(int)((float)event.xbutton.y/magy);
                                         dxpos=(int)((float)event.xbutton.x/magx);
                                         if(dxpos>=0 && dxpos <vx && dypos >=0 && dypos<vy)
                                           {sprintf(info,"X:%03d Y:%03d Z:%03d",
                                                    dxpos,dypos,*(dat[dypos]+dxpos));
                                            XDrawImageString(dpy,win,mygc,posx,posy,
                                                             info,strlen(info));
					    }
			                 }
				     }			
                                  break;
		case MappingNotify:XRefreshKeyboardMapping(&event);
						   break;
		case KeyPress:znak=XLookupString(&event,text,10,&mykey,0);
                              if(znak==1)
                                 {text[0]=tolower(text[0]);
                                  if(text[0]=='q'){leave=1;done=1;}
				  if(text[0]=='i'){invert(dat,vx,vy);leave=1;}
				  if(text[0]=='r'){root=1;leave=1;}
				  if(text[0]=='m')
                                     {if(magx>MGMIN)
					{magx=magx/2;leave=1;}
                                      if(magy>MGMIN)
				        {magy=magy/2;leave=1;}
                                      }
                                  if(text[0]=='v')
                                     {if(magx<MGMAX)
					{magx=magx*2;leave=1;}
				      if(magy<MGMAX)
				        {magy=magy*2;leave=1;}
                                      }
                                  if(text[0]=='o'){magx=1;magy=1;leave=1;}
                                  }
                                  break;
             }
           }
	 free(image->data);
	 XFlush(dpy);
	 XFreeGC(dpy,mygc);
	 XDestroyWindow(dpy,win);
	 }
	while(done==0);
 }
